function [dnl,inl,offset] = idnl(a_in,d_code,num_bit)
% Calculate DNL and INL.

d_length = d_code(length(d_code))-d_code(1)+1;
[y_hist,x_hist] = hist(d_code,d_length);
y_hist = y_hist(2:d_length-1)';

[X,I] = min(abs(a_in));
offset = d_code(I)-1;

dnl = (y_hist-mean(y_hist))/mean(y_hist);
inl = [0;cumsum(dnl)];
dnl = [dnl;zeros(2^num_bit-length(dnl),1)];
inl = [inl;zeros(2^num_bit-length(inl),1)];
